
import java.net.*;
import java.io.*;
import java.nio.*;
import java.util.regex.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.text.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import javax.swing.table.*;
import javax.swing.event.*;
import java.nio.channels.*;
import java.awt.image.*;
import javax.imageio.*;
import javax.net.*;
import javax.net.ssl.*;
import java.security.*;
import java.util.jar.*;
import java.security.cert.*;
import java.math.*;

import org.jdom.*;
import org.jdom.adapters.*;
import org.jdom.filter.*;
import org.jdom.input.*;
import org.jdom.output.*;
import org.jdom.transform.*;
import org.jdom.xpath.*;

public class Spot implements Comparable<Spot> {
    
    public int x;
    public int y;
    
    public Spot(int x, int y) {
        this.x = x;
        this.y = y;
    }
    
    public Spot(String s) {
        Matcher m = Pattern.compile("(\\d*)\\D+(\\d*)").matcher(s);
        if (m.find()) {
            x = new Integer(m.group(1));
            y = new Integer(m.group(2));
        } else {
            throw new IllegalArgumentException("invalid spot representation: " + s);
        }
    }
    
    public int hashCode() {
        return (x << 16) + y;
    }
    
    public boolean equals(Object o) {
        Spot that = (Spot)o;
        
        return this.x == that.x && this.y == that.y;
    }
    
    public int compareTo(Spot that) {
        if (this.x == that.x) {
            return new Integer(this.y).compareTo(that.y);
        } else {
            return new Integer(this.x).compareTo(that.x);
        }
    }
    
    public String toString() {
        return "" + x + ", " + y;
    }
}
